#include <stdio.h>

#define MAX_RIGHE 5 
#define MAX_COLONNE 5

typedef struct {
    int r;
    int c;
} cella_t;

int trova_ciclo(cella_t matrice[MAX_RIGHE][MAX_COLONNE], int r, int c);

// (0, 0) definisce un ciclo!
cella_t M[MAX_RIGHE][MAX_COLONNE] = {
    {{3,2}, {3,3}, {0,4}, {0,2}, {1,4}},
    {{0,4}, {3,0}, {2,1}, {4,2}, {0,0}},
    {{1,0}, {0,3}, {0,4}, {0,4}, {4,4}},
    {{2,1}, {4,1}, {2,4}, {3,3}, {4,3}},
    {{0,2}, {3,4}, {3,0}, {4,2}, {0,0}}
};

int main() {
    printf("%d\n", trova_ciclo(M, 5, 5));
}

int trova_ciclo(cella_t matrice[MAX_RIGHE][MAX_COLONNE], int r, int c) {
    cella_t curr, tmp, init;

    scanf("%d", &init.r);
    scanf("%d", &init.c);

    curr.r = init.r;
    curr.c = init.c;

    printf("%d %d\n", curr.r, curr.c);

    for (int i=0; i<r*c; i++) {
        tmp.r = matrice[curr.r][curr.c].r;
        tmp.c = matrice[curr.r][curr.c].c;
        curr.r = tmp.r;
        curr.c = tmp.c;
        printf("%d %d\n", curr.r, curr.c);
        if (curr.r == init.r && curr.c == init.c) {
            return 1;
        }
    }
    return 0;
}