#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int controlla_permutazione(int *p, int lung);
int applica_permutazione(char *str, int *p, int lung);

int main() {
    int lunghezza;
    int *p;
    char str[256];

    scanf("%d", &lunghezza);
    p = malloc(sizeof(int) * lunghezza);

    for (int i=0; i<lunghezza; i++) {
        scanf("%d", &p[i]);
    }
    
    scanf("%s", str);

    applica_permutazione(str, p, lunghezza);
    printf("%s\n", str);
}


int controlla_permutazione(int *p, int lung) {
    int cnt;
    for (int i=0; i<lung; i++) {
        cnt = 0;
        for (int j=0; j<lung; j++) {
            if (p[j] == i) {
                cnt++;
            }
        }
        if (cnt != 1) {
            return 0;
        }
    }
    return 1;
}

int applica_permutazione(char *str, int *p, int lung) {
    char tmp;
    char *str_cpy = malloc(sizeof(char) * (lung+1));

    if (!controlla_permutazione(p, lung) || strlen(str) != lung) {
        return 0;
    }

    strcpy(str_cpy, str);

    for (int i=0; i<lung; i++) {
        str[p[i]] = str_cpy[i];
    }
    
    free(str_cpy);
    return 1;
}